<?php 
ob_start('ob_gzhandler');
include('../../api/config.php');

$Data = json_decode(file_get_contents('php://input'));
$PerToken = trim($Data->PerToken);
$PerUserID = trim($Data->PerUserID);
$PerRoleID = trim($Data->PerRoleID);

$UserCheck = $mysqli->query("SELECT Token FROM `login_tokens` WHERE `UID` = '$PerUserID' and `Token` = '$PerToken' limit 1");
$UserCheckRow = mysqli_num_rows($UserCheck);

if($UserCheckRow == 0){
    $return["error"] = true;
    $return["message"] = "Access denied!";
} else {
    $Visits = $Data->Visits; // Array of visits
    $errors = [];
    $mysqli->begin_transaction();

    try {
        foreach($Visits as $visit) {
            $VisitID = $visit->VisitID;
            $InspectorID = $visit->InspectorID;
            $ProjectID = $visit->ProjectID;
            $Type = $visit->Type;
            $Date = $visit->Date;

            $ProjectIDi = $ProjectID != '' ? " , `ProjectID` = '$ProjectID'" : "";
            $Typei = $Type != '' ? " , `Type` = '$Type'" : "";
            $Datei = $Date != '' ? " , `Date` = '$Date'" : "";

            $stmt = $mysqli->prepare("UPDATE `Site_Visits` SET `InspectorID` = ? $ProjectIDi $Typei $Datei WHERE `VisitID` = ?");
            $stmt->bind_param("ii", $InspectorID, $VisitID);

            if(!$stmt->execute()){
                throw new Exception("Error updating visit with VisitID: $VisitID");
            }

            $stmt->close();
        }

        $mysqli->commit();
        $return["error"] = false;
        $return["message"] = "All visits updated successfully!";
    } catch (Exception $e) {
        $mysqli->rollback();
        $return["error"] = true;
        $return["message"] = $e->getMessage();
    }
}

header('Content-Type: application/json');
echo json_encode($return);
?>
