<?php

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

ob_start('ob_gzhandler');
include('../api/config.php');

require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/Exception.php';
require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/PHPMailer.php';
require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/SMTP.php';
require '../../inspection.cpvarabia.com/wordlib/vendor/autoload.php';

$TodayIs = date("Y-m-d H:i:s");
$Last120Min = date('Y-m-d H:i:s', strtotime('-15 minutes'));
$Project = $mysqli->query("SELECT DISTINCT * FROM `TicketCorn` WHERE `CreatedAt` <= '$Last120Min' limit 10");
while ($Projects = mysqli_fetch_array($Project)) {
    if (count($Projects) > 0) {
        $ProjectID = $Projects['ProjectID'];
        $StageID =  $Projects['StageID'];
        $PStageID =  $Projects['PStageID'];

        // Get the maximum 'Rev' for the given ProjectID
        $res2 = $mysqli->query("SELECT MAX(`Rev`) as Rev FROM `project_stages` WHERE `ProjectID` = '$ProjectID' and StageID  = '10'");
        $row2 = mysqli_fetch_array($res2);
        $rev = (!is_numeric($row2['Rev'])) ? " , p1.`Rev` = '0' " : " , p1.`Rev` = '" . ($row2['Rev'] + 1) . "'";


        $res5 = $mysqli->query("SELECT * FROM `Special_Projects` WHERE `ProjectID` = '$ProjectID'");
        $row5 = $res5->fetch_assoc();
        $Precast = $row5['Precast'];
        $Steel = $row5['Steel'];

        $res5 = $mysqli->query("SELECT `Special` FROM `projects` WHERE `ProjectID`= '$ProjectID'");
        $row5 = $res5->fetch_assoc();
        $Special = $row5['Special'];

        $resx8r = $mysqli->query("SELECT `TicketID`, `UserID` FROM `project_tickets` WHERE `TicketID` NOT IN (SELECT TicketID FROM `tickets_emails_history` 
        WHERE `Action` =1 and `Deleted` = '0') and `TicketID` NOT IN (SELECT TicketID FROM `project_tickets` WHERE `DegreeID` is NULL and `Deleted` = '0') 
        and `ProjectID` = '$ProjectID' and `StageID` = '$StageID' ORDER BY `TicketID` DESC");
        if (count($resx8r) > 0) {

            $row8r = mysqli_fetch_array($resx8r);
            $TicketID = $row8r['TicketID'];
            $issuerID = $row8r['UserID'];
            $res5 = $mysqli->query("SELECT OwnerID as OID, ConstructorID as CID, ReferenceNo, Token FROM projects where`ProjectID` = '$ProjectID' and Deleted = '0'");
            $row5 = $res5->fetch_assoc();
            $ReferenceNo = $row5['ReferenceNo'];
            $Token = $row5['Token'];

            $resx10 = $mysqli->query("SELECT `Email` FROM `users` WHERE `UserID` = '$issuerID'");
            $row10 = mysqli_fetch_array($resx10);
            $Usermail = $row10['Email'];

            $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row5['OID'] . "'");
            $row11 = mysqli_fetch_array($resx11);
            $OE = $row11['Email'];
            $OwnerName = $row11['Name'];
            $OMobile = 966 . substr($row11['Mobile'], -9);

            $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row5['CID'] . "'");
            $row12 = mysqli_fetch_array($resx12);
            $CE = $row12['Email'];
            $CMobile = 966 . substr($row12['Mobile'], -9);

            //-------------------org------------------
            $resx13 = $mysqli->query("SELECT org_chart.Supervisor FROM `project_locations`,org_chart WHERE `project_locations`.`Org` = org_chart.OCID AND `project_locations`.`ProjectID` = '$ProjectID'");
            $row13 = mysqli_fetch_array($resx13);

            $res99 = $mysqli->query("SELECT `Email` FROM `users` WHERE `UserID` = '" . $row13['Supervisor'] . "'");
            $row99 = mysqli_fetch_array($res99);
            $insariamail = $row99['Email'];
            //-------------------------------------
            if ($Special == 1) {
                $res5 = $mysqli->query("SELECT `ParentID` FROM `roles` WHERE `ResourceID` = '28' AND `Permissions` != '0' and `Deleted` = '0'");
                $SPEmails = array();
                while ($row5 = mysqli_fetch_array($res5)) {
                    $ParentID = $row5['ParentID'];

                    $OptionID20 = $row5['OptionID'];
                    $res7 = $mysqli->query("SELECT `Email` FROM `users` WHERE `RoleID` = '$ParentID'  and Deleted = '0' ");
                    while ($row7 = mysqli_fetch_array($res7)) {
                        $SPEmails[] = $row7['Email'];
                    }
                }
            }
            //-------------------------------------
            $r34x8r = $mysqli->query("SELECT TicketID FROM `project_tickets` WHERE `StageID` = '$StageID' and `ProjectID` = '$ProjectID' and `DegreeID` is NULL and `Deleted` = '0'");
            $r34x8rCo = mysqli_num_rows($r34x8r);
            if ($r34x8rCo == 0) {
                $r34x8r65 = $mysqli->query("SELECT TicketID FROM `tickets_emails_history` WHERE `TicketID` = '$TicketID' and `Action` =1 and `Deleted` = '0'");
                $r34x8rCo56 = mysqli_num_rows($r34x8r65);
                if ($r34x8rCo56 == 0) {
                    $return["EmailStatus"] = true;
                    $data = [
                        'userName' => $smsuserName,
                        'numbers' => $OMobile, $CMobile,
                        'userSender' => $smsuserSender,
                        'apiKey' => $smsapiKey,
                        'msg' => 'عزيزنا العميل،
تجدون الملاحظات الفنية لمشروعكم ' . $ReferenceNo . ' عبر الرابط ( tickets.cpvarabia.com/?Tr=' . $Token . ' )',
                    ];

                    // Initialize cURL session
                    $ch = curl_init();

                    // Set cURL options
                    curl_setopt($ch, CURLOPT_URL, $smsapiUrl);
                    curl_setopt($ch, CURLOPT_POST, true);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
                    curl_setopt($ch, CURLOPT_HTTPHEADER, [
                        'Content-Type: application/json',
                        'Cookie: SERVERID=MBE2', // Include any other headers as needed
                    ]);

                    // Receive server response
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

                    // Execute cURL session
                    $response = curl_exec($ch);

                    // Close cURL session
                    curl_close($ch);


                    $url = 'https://wp.designal.cc/api/v1/chats/' . $CMobile . '/messages/multi-templates';
                    $data = array(
                        "templateName" => "notes_rd0",
                        "ref" => $ReferenceNo,
                        "link" => 'tickets.cpvarabia.com/?Tr=' . $Token . ' ',
                    );
                    $return["url"] = $url;
                    $headers = array(
                        'Content-Type: application/json',
                        'Authorization:  Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6IjY1Yjk2OTE2NjBjYTJiYzU5NmYxZGI0MyIsImlhdCI6MTcxNTAwNTU0MywiZXhwIjoxNzIyNzgxNTQzfQ.XwW8rH9kuu9zkMy2QV4c4w4eYkny6qInv5wM95Tfios'
                    );

                    $ch = curl_init($url);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
                    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

                    $response = curl_exec($ch);
                    curl_close($ch);

                    $return["url"] = $response;
                    $return["udrl"] = $url;


                    $mail = new PHPMailer(true);

                    try {
                        //Server settings
                        //$mail->SMTPDebug = SMTP::DEBUG_SERVER;                      //Enable verbose debug output
                        $mail->isSMTP();                                            //Send using SMTP
                        $mail->Host       = 'mail.rdapp.net';                     //Set the SMTP server to send through
                        $mail->SMTPAuth   = true;                                   //Enable SMTP authentication
                        $mail->Username   = 'cpvtest@rdapp.net';                     //SMTP username
                        $mail->Password   = 'x39cyh2a2es5';                               //SMTP password
                        $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;            //Enable implicit TLS encryption
                        $mail->Port       = 465;                                    //TCP port to connect to; use 587 if you have set `SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS`
                        $mail->CharSet = 'UTF-8';
                        $mail->SMTPOptions = array(
                            'ssl' => array(
                                'verify_peer' => false,
                                'verify_peer_name' => false,
                                'allow_self_signed' => true
                            )
                        );
                        //Recipients
                        $mail->setFrom('cpvtest@rdapp.net', 'CPV Arabia Tools');

                        if (!empty($CE) && !empty($OE)) {
                            $mail->addAddress($CE);
                            $mail->addCC($OE, $OwnerName);
                            $mail->addCC('design@cpvarabia.com');
                            $mail->addCC('CS@cpvarabia.com');
                            $mail->addBCC('cpvtest@rdapp.net');
                            $mail->addCC('IDI@Malath.com.sa');
                            if (!empty($insariamail)) {
                                $mail->addCC($insariamail);
                            }
                            if (!empty($Usermail)) {
                                $mail->addCC($Usermail);
                            }
                         
                        } elseif (!empty($OE) && empty($CE)) {
                            $mail->addAddress($OE, $OwnerName);
                            $mail->addCC('design@cpvarabia.com');
                            $mail->addCC('CS@cpvarabia.com');
                            $mail->addBCC('cpvtest@rdapp.net');
                             $mail->addCC('IDI@Malath.com.sa');
                            if (!empty($insariamail)) {
                                $mail->addCC($insariamail);
                            }
                            if (!empty($Usermail)) {
                                $mail->addCC($Usermail);
                            }
                       
                        } elseif (!empty($CE) && empty($OE)) {
                            $mail->addAddress($CE);
                            $mail->addCC('design@cpvarabia.com');
                            $mail->addCC('CS@cpvarabia.com');
                            $mail->addBCC('cpvtest@rdapp.net');
                            if (!empty($insariamail)) {
                                $mail->addCC($insariamail);
                            }
                            if (!empty($Usermail)) {
                                $mail->addCC($Usermail);
                            }
                     
                        }
                          if ($Special == 1) {
                                     if (!empty($SPEmails)) {

                                for ($i = 0; $i < count($SPEmails); $i++) {
                                    $mail->addCC($SPEmails[$i]);
                                }
                            }
                          }
                        if ($Special == 1 && $Steel == '1') {
                        } else if ($Special == 1 && $Steel == '2') {
                            $mail->addAttachment("../uploads/SteelStructureProjectsContractorGuidelinesAR.pdf", "Ar Steel Structure Contractor Guidelines");
                            $mail->addAttachment("../uploads/SteelStructureProjectsContractorGuidelinesEN.pdf", "EN Steel Structure Contractor Guidelines");
                        }

                        if ($Special == 1 && $Precast == '1') {
                        } else if ($Special == 1 && $Precast == '2') {
                            $mail->addAttachment("../uploads/PrecastProjectsContractorGuidelinesAR.pdf", "Ar Precast Contractor Guidelines");
                            $mail->addAttachment("../uploads/PrecastProjectsContractorGuidelinesEN.pdf", "EN Precast Contractor Guidelines");
                        }
                        if ($Special == 0) {
                            $mail->addAttachment("../uploads/ContractorGuidelinesAR.pdf", "Ar Contractor Guidelines");
                            $mail->addAttachment("../uploads/ContractorGuidelinesEN.pdf", "EN Contractor Guidelines");
                        }
                        //Content
                        $mail->isHTML(true);                                  //Set email format to HTML
                        $mail->Subject = 'TIS # ' . $ReferenceNo . ' Report updates: ';
                        $mail->Body = '';

                        $mail->Body .= '<body style="text-align:right; direction:rtl;"></ol></p>
                                <p>عزيزى العميل :  ' . $OwnerName . ' <br />
                                نحن شركه CPV ARABIA نرحب بسيادتكم، وهي الشركة التي تم تعيينها من قبل شركه MALATH للتأمين لتزويدكم بخدمات الفحص الفني TIS للمشروع<br />
                                رقم الطلب المرجعي : ' . $ReferenceNo . '<br />
                                نفيدكم بأنه قد تمت عملية المراجعة والتدقيق للمخططات والمستندات الهندسية وتقرير التربة والتكلفة والمعايير الأخرى وإصدار التقرير الفني الأولي الخاص بمشروعكم من أجل البدء في تفعيل تأمين العيوب الخفية للمشروع. <br />
                                ووجد أثناء المراجعة طبقاً للكود السعودي للبناء بعض النقاط الفنية، نرجو من سيادتكم أخذها محض الاهتمام وذلك لضمان جودة المنشأ وسلامته: <br />';

                        $DS4 = $mysqli->query("SELECT `TicketID` FROM `project_tickets` WHERE `StageID` = '$StageID' and `ProjectID` = '$ProjectID' and `DegreeID` = '1'");
                        $numDS4 = mysqli_num_rows($DS4);
                        if ($numDS4 > 0) {
                            $mail->Body .= '</ol></p>
                                    <p><b>#مخاطر خاصة بالتصميم قد تهدد سلامة المبنى</b> (يتم حلها بإرسال سيادتكم للمستندات المطلوبة</b> قبل<b> زيارة المهندس الفاحص الفني إلى الموقع):</p>
                                    <ol>';
                            while ($D4 = mysqli_fetch_array($DS4)) {
                                $resx4 = $mysqli->query("SELECT `CommentAR`, `CorrectiveAR` FROM `project_tickets` WHERE `TicketID`=  '" . $D4['TicketID'] . "' AND `Deleted` = '0'");
                                while ($row4 = mysqli_fetch_array($resx4)) {
                                    if (count($row4) > 0) {
                                        $mail->Body .= "<li>$row4[CommentAR]</li>";
                                        $mail->Body .= "- $row4[CorrectiveAR]";
                                    } else {
                                        $mail->Body .= "لا يوجد.";
                                    }
                                }
                            }
                        } else {
                        }

                        $DS3 = $mysqli->query("SELECT `TicketID` FROM `project_tickets` WHERE `StageID` = '$StageID' and `ProjectID` = '$ProjectID' and `DegreeID` = '5'");
                        $numDS3 = mysqli_num_rows($DS3);
                        if ($numDS3 > 0) {
                            $mail->Body .= '</ol></p>
                                    <p><b>#مخاطر خاصة بمرحلة التنفيذ <b>(يتم إغلاقها مع سيادتكم في الموقع </b>أثناء<b> زيارة المهندس الفاحص الفني إلى الموقع):</p>
                                    <ol>';
                            while ($D3 = mysqli_fetch_array($DS3)) {
                                $resx3 = $mysqli->query("SELECT `CommentAR`, `CorrectiveAR` FROM `project_tickets` WHERE `TicketID`=  '" . $D3['TicketID'] . "' AND `Deleted` = '0'");
                                while ($row3 = mysqli_fetch_array($resx3)) {
                                    if (count($row3) > 0) {
                                        $mail->Body .= "<li>$row3[CommentAR]</li>";
                                        // $mail->Body .= "- $row3[CorrectiveAR]";
                                    } else {
                                        $mail->Body .= "لا يوجد.";
                                    }
                                }
                            }
                        } else {
                        }

                        $DS2 = $mysqli->query("SELECT `TicketID` FROM `project_tickets` WHERE `StageID` = '$StageID' and `ProjectID` = '$ProjectID' and `DegreeID` in (2,3)");
                        $numDS2 = mysqli_num_rows($DS2);
                        if ($numDS2 > 0) {
                            $mail->Body .= '</ol></p>
                                    <p><b>#تحفظات فنية وملاحظات:</b></p>
                                    <ol>';
                            while ($D2 = mysqli_fetch_array($DS2)) {
                                $resx2 = $mysqli->query("SELECT `CommentAR`, `CorrectiveAR`,`DegreeID`  FROM `project_tickets` WHERE `TicketID`=  '" . $D2['TicketID'] . "' AND `Deleted` = '0'");
                                while ($row2 = mysqli_fetch_array($resx2)) {
                                    if (count($row2) > 0) {
                                        $mail->Body .= "<li>$row2[CommentAR]</li>";
                                          if (!empty($row2['DegreeID']) and $row2['DegreeID'] == 2) {
                                            $mail->Body .= "- $row2[CorrectiveAR]";
                                        }
                                    } else {
                                        $mail->Body .= "لا يوجد.";
                                    }
                                }
                            }
                        } else {
                        }

                        $mail->Body .= '</p>
                                <p>الرجاء مراجعة ما ذكر أعلاه مع المكتب الهندسي المصمم أو مختبر التربة -كل حسب تخصصه- وكذلك ملف تعليمات المقاول المرفق، حرصاً على سلامة المنشأ، وسوف يتم إغلاق الملاحظات توالياً في حال استيفاء المتطلبات طبقا للشروط.<br />
                                </p>';

                        $mail->Body .= ' <body style="text-align:right; direction:ltr;">
                                    <p>“Dear Sir,' . $OwnerName . '.<br />
                                    I hope you are doing well.<br />
                                    This is CPV Arabia company which is assigned by MALATH insurance company to provide you with TIS (technical inspection services) for the subject project. # Ref. ' . $ReferenceNo . '.<br />
                                    To activate the Inherent Defects Insurance for your project, we have to review several documents concerning the project design, cost, and other criteria.<br />
                                    Some technical points were found during the review according to the Saudi Building Code. So, Kindly we ask you to take them seriously to ensure the quality and stability of the structure:</p>';




                        $DS4 = $mysqli->query("SELECT `TicketID` FROM `project_tickets` WHERE `StageID` = '$StageID' and `ProjectID` = '$ProjectID' and `DegreeID` = '1'");
                        $numDS4 = mysqli_num_rows($DS4);
                        if ($numDS4 > 0) {
                            $mail->Body .= '</ol></p>
                                            <p><b># Design observations may affect the building stability</b> (to be resolved by your side by sending the required documents <b>before</b> the technical site inspection visit):</p>
                                            <ol>';
                            while ($D4 = mysqli_fetch_array($DS4)) {

                                $resx4 = $mysqli->query("SELECT `Description`, `CorrectiveEN`  FROM `project_tickets` WHERE `TicketID`=  '" . $D4['TicketID'] . "' AND `Deleted` = '0'");
                                while ($row4 = mysqli_fetch_array($resx4)) {
                                    if (count($row4) > 0) {
                                        $mail->Body .= "<li>$row4[Description]</li>";
                                        $mail->Body .= "- $row4[CorrectiveEN]";
                                    } else {
                                        $mail->Body .= "-not found.";
                                    }
                                }
                            }
                        } else {
                        }

                        $DS3 = $mysqli->query("SELECT `TicketID` FROM `project_tickets` WHERE `StageID` = '$StageID' and `ProjectID` = '$ProjectID' and `DegreeID` = '5'");
                        $numDS3 = mysqli_num_rows($DS3);
                        if ($numDS3 > 0) {
                            $mail->Body .= '</ol></p>
                                            <p><b># Execution stage observations</b> (to be closed with you on-site <b>during</b> the technical site inspection visit):</p>
                                            <ol>';
                            while ($D3 = mysqli_fetch_array($DS3)) {

                                $resx3 = $mysqli->query("SELECT `Description`, `CorrectiveEN`  FROM `project_tickets` WHERE `TicketID`=  '" . $D3['TicketID'] . "' AND `Deleted` = '0'");
                                while ($row3 = mysqli_fetch_array($resx3)) {
                                    if (count($row3) > 0) {
                                        $mail->Body .= "<li>$row3[Description]</li>";
                                        //   $mail->Body .= "- $row3[CorrectiveEN]";
                                    } else {
                                        $mail->Body .= "-not found.";
                                    }
                                }
                            }
                        } else {
                        }

                        $DS2 = $mysqli->query("SELECT `TicketID` FROM `project_tickets` WHERE `StageID` = '$StageID' and `ProjectID` = '$ProjectID' and `DegreeID` in (2,3)");
                        $numDS2 = mysqli_num_rows($DS2);
                        if ($numDS2 > 0) {
                            $mail->Body .= '</ol></p>
                                        <p><b># Technical Reservations and Notes:</b></p>
                                        <ol>';
                            while ($D2 = mysqli_fetch_array($DS2)) {

                                $resx2 = $mysqli->query("SELECT `Description`, `CorrectiveEN` FROM `project_tickets` WHERE `TicketID`=  '" . $D2['TicketID'] . "' AND `Deleted` = '0'");
                                while ($row2 = mysqli_fetch_array($resx2)) {
                                    if (count($row2) > 0) {
                                        $mail->Body .= "<li>$row2[Description]</li>";
                                         if (!empty($row2['DegreeID']) and $row2['DegreeID'] == 2) {
                                            $mail->Body .= "- $row2[CorrectiveEN]";
                                        }
                                    } else {
                                        $mail->Body .= "-not found.";
                                    }
                                }
                            }
                        } else {
                        }
                        $mail->Body .= '</p>
    <p>So, kindly review the points mentioned above with the Design Engineering Office or the Soil Laboratory, and the attached Contractor`s Guidelines file, which are crucial for the building stability, and your observations will be closed sequentially according to the requirements fulfillment conditions.<br />
    </p>';

                        if ($mail->send()) {
                            $r66631r = $mysqli->query("SELECT TicketID FROM `project_tickets` WHERE `StageID` = '$StageID' and `ProjectID` = '$ProjectID' and `DegreeID` is not NULL");

                            while ($r778r = mysqli_fetch_array($r66631r)) {
                                $mysqli->query("INSERT INTO `tickets_emails_history` (`TicketID`, `UserID`, `Action`, `CreatedAt`) VALUES ('" . $r778r['TicketID'] . "', '$issuerID', '1', '$TodayIs')");
                            }
                        }
                        $mysqli->query("DELETE FROM `TicketCorn` WHERE `ProjectID` = '$ProjectID' AND `StageID` = '$StageID' ");
                        // $mysqli->query("UPDATE `project_stages` AS p1 JOIN ( SELECT MAX(`PStageID`) AS max_pstage_id FROM `project_stages` WHERE `Status` = 'Approved' AND `Deleted` = '0' AND `StageID` = '$StageID' AND `ProjectID` = '$ProjectID' ) AS p2 ON p1.`PStageID` = p2.max_pstage_id SET $rev");
                        $return["error"] = false;
                    } catch (Exception $e) {
                        $return["error"] = true;
                        $return["message"] = "Message could not be sent. Mailer Error: {$mail->ErrorInfo}";
                    }


                    $return["EmailStatus"] = true;
                } else {
                    $return["EmailStatus"] = false;
                }
            } else {
                $return["EmailStatus"] = false;
            }
        } else {
            $return["EmailStatus"] = false;
        }
    } else {
        $return["EmailStatus"] = false;
    }
}

header('Content-Type: application/json');
echo json_encode($return);
