<?php

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

ob_start('ob_gzhandler');
include('../api/config.php');

require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/Exception.php';
require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/PHPMailer.php';
require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/SMTP.php';
require '../../inspection.cpvarabia.com/wordlib/vendor/autoload.php';

$TodayIs = date("Y-m-d H:i:s");

$Tickets = $mysqli->query("SELECT te.TicketID, te.UserID
FROM project_tickets pt
INNER JOIN tickets_emails_history te ON pt.TicketID = te.TicketID
WHERE pt.DegreeID = 1
AND te.Action = 2
AND te.CreatedAt <= DATE_SUB(NOW(), INTERVAL 120 HOUR)
AND NOT EXISTS (
    SELECT 1
    FROM tickets_emails_history te2
    WHERE te2.TicketID = pt.TicketID
    AND te2.Action = 3)");
while ($TicketIDs = mysqli_fetch_array($Tickets)) {
    if (count($TicketIDs) > 0) {
        $TicketID =  $TicketIDs['TicketID'];
        $PerUserID =  $TicketIDs['UserID'];

        $resx8r = $mysqli->query("SELECT ProjectID, StageID, UserID  FROM project_tickets WHERE TicketID = '$TicketID'");
        $row8r = mysqli_fetch_array($resx8r);
        $TProjectID = $row8r['ProjectID'];
        $TStageID = $row8r['StageID'];
        $issuerID = $row8r['UserID'];
        $res5 = $mysqli->query("SELECT projects.OwnerID as OID, projects.ConstructorID as CID, projects.ReferenceNo FROM project_tickets, projects where project_tickets.ProjectID = projects.ProjectID  and `TicketID` = '$TicketID' and project_tickets.Deleted = '0'");
        $row5 = $res5->fetch_assoc();
        $ReferenceNo = $row5['ReferenceNo'];

        $resx10 = $mysqli->query("SELECT `CreatedAt` FROM `tickets_emails_history` WHERE `TicketID` = '$TicketID' and `Action` = 1");
        $row10 = mysqli_fetch_array($resx10);
        $CreatedAt1 = $row10['CreatedAt'];
        $dt = new DateTime($CreatedAt1);
        $notdate = $dt->format('d-M-Y');

        $resx10 = $mysqli->query("SELECT `CreatedAt` FROM `tickets_emails_history` WHERE `TicketID` = '$TicketID' and `Action` = 2");
        $row10 = mysqli_fetch_array($resx10);
        $CreatedAt2 = $row10['CreatedAt'];
        $dt2 = new DateTime($CreatedAt2);
        $notdate2 = $dt2->format('d-M-Y');

        $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row5['OID'] . "'");
        $OE = $row11['Email'];
        $OwnerName = $row11['Name'];
        
        $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row5['CID'] . "'");
        $row12 = mysqli_fetch_array($resx12);
        $CE = $row12['Email'];

        $r34x8r = $mysqli->query("SELECT TicketID FROM `project_tickets` WHERE `StageID` = '$TStageID' and `ProjectID` = '$TProjectID' and `DegreeID`= '1' and `Deleted` = '0'");
        $r34x8rCo = mysqli_num_rows($r34x8r);
        if ($r34x8rCo > 0) {

            $r34x8r65 = $mysqli->query("SELECT TicketID FROM `tickets_emails_history` WHERE `TicketID` = '$TicketID' and `Action` =3 and `Deleted` = '0'");
            $r34x8rCo56 = mysqli_num_rows($r34x8r65);
            if ($r34x8rCo56 == 0) {
                $return["EmailStatus"] = true;
                $mail = new PHPMailer(true);

                try {
                    //Server settings
                    //$mail->SMTPDebug = SMTP::DEBUG_SERVER;                      //Enable verbose debug output
                    $mail->isSMTP();                                            //Send using SMTP
                    $mail->Host       = 'mail.rdapp.net';                     //Set the SMTP server to send through
                    $mail->SMTPAuth   = true;                                   //Enable SMTP authentication
                    $mail->Username   = 'cpvtest@rdapp.net';                     //SMTP username
                    $mail->Password   = 'x39cyh2a2es5';                               //SMTP password
                    $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;            //Enable implicit TLS encryption
                    $mail->Port       = 465;                                    //TCP port to connect to; use 587 if you have set `SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS`
                    $mail->CharSet = 'UTF-8';

                    //Recipients
                    $mail->setFrom('cpvtest@rdapp.net', 'CPV Arabia Tools');

                    if (!empty($CE) && !empty($OE)) {
                        $mail->addAddress($CE);
                        $mail->addCC($OE, $OwnerName);
                        $mail->addCC('design@cpvarabia.com');
                        $mail->addCC('CS@cpvarabia.com');
                        $mail->addBCC('cpvtest@rdapp.net');
                        $mail->addCC('IDI@Malath.com.sa');
                    } elseif (!empty($OE) && empty($CE)) {
                        $mail->addAddress($OE, $OwnerName);
                        $mail->addCC('design@cpvarabia.com');
                        $mail->addCC('CS@cpvarabia.com');
                        $mail->addBCC('cpvtest@rdapp.net');
                        $mail->addCC('IDI@Malath.com.sa');
                    } elseif (!empty($CE) && empty($OE)) {
                        $mail->addAddress($CE);
                        $mail->addCC('design@cpvarabia.com');
                        $mail->addCC('CS@cpvarabia.com');
                        $mail->addBCC('cpvtest@rdapp.net');
                        $mail->addCC('IDI@Malath.com.sa');
                    } else {
                    }
                    //Content
                    $mail->isHTML(true);                                  //Set email format to HTML
                    $mail->Subject = 'TIS # ' . $ReferenceNo . ' Report updates 2nd reminder: ';
                    $mail->Body = '';

            

                    $mail->Body .= '<body style="text-align:right; direction:rtl;"></ol></p>
                            <p>عزيزى العميل :  ' . $OwnerName . ' <br />
                            نحن شركه CPV ARABIA نرحب بسيادتكم، وهي الشركة التي تم تعيينها من قبل شركه MALATH للتأمين لتزويدكم بخدمات الفحص الفني TIS للمشروع<br />
                            رقم الطلب المرجعي : ' . $ReferenceNo . '<br />
                            تم المراجعه والتدقيق للرسومات الهندسية وتقرير التربة والمستندات والتكلفة والمعايير الأخرى وعمل التقرير الأولى لسيادتكم من أجل إجراء التأمين للمشروع .<br />
                            أثناء مراجعة مستندات التصميم الخاصة بالمشروع وجد بعض الملاحظات وتم إرسالها مسبقا لسيادتكم في تاريخ ' . $notdate . '  وتم التذكير  لسيادتكم بالملاحظات في تاريخ' . $notdate2 . ' <br />
                            ,وعليه نفيد سيادتكم بأن حالة المشروع فى الوقت الحا
                            لى متوقفة لحين إرسال البيانات المطلوبة وذلك لضمان سلامة المنشأ وجودة العمل . ودفعاً لسير العمل نفيدكم أنه بمجرد إرسال البيانات المطلوبة فإنه لا مانع من المراجعة، وفي حال استيفاء الملاحظات فلامانع من الرجوع إلى وتيرة العمل بشكل طبيعي ..<br />
                            الرقم الموحد لخدمة العملاء والشكاوى (اتصال) 920034242<br />
الرقم الموحد لخدمة العملاء والشكاوى (واتساب) 00966920034242<br />
أوقات العمل الرسمية من الأحد إلى الخميس من الساعة 9 صباحاً وحتى الساعه 5 مساءاً . <br />
نشكركم لحسن التعاون المشترك ونتمني ان تنال خدمتنا رضاكم. <br />
                            CPV ARABIA<br />';
                            $mail->Body .= '
                            <p>“Dear Sir,' . $OwnerName . '.<br />
                            I hope you are doing well.<br />
                            This CPV Arabia company is assigned by MALATH insurance company to provide you with TIS (technical inspection services) for the subject project. # Ref. ' . $ReferenceNo . '.<br />
                            In order to perform the insurance for your project, we have to review several documents concerning structural, cost, and other criteria.<br />
                            During the review of the attachments, some observations were found, and they were previously sent to you on the date ' . $notdate . '
                            Your excellency was reminded of the notes on the date ' . $notdate2 . '. <br />
                            , and accordingly, we inform you that the status of the project at the present time is suspended until the required data is sent in order to ensure the quality of the job. And in order to push the workflow, we inform you that once the required data is sent, it will be reviewed and if the observation were closed the work can be continued.</p>';


                    if ($mail->send()) {
                        $r66631r = $mysqli->query("SELECT te.TicketID , pt.UserID
                        FROM project_tickets pt
                        INNER JOIN tickets_emails_history te ON pt.TicketID = te.TicketID
                        WHERE pt.DegreeID = 1 AND te.Action = 2 AND te.CreatedAt <= DATE_SUB(NOW(), INTERVAL 120 HOUR) AND pt.StageID = '$TStageID'
AND NOT EXISTS (
    SELECT 1
    FROM tickets_emails_history te2
    WHERE te2.TicketID = pt.TicketID
    AND te2.Action = 3
)");

                        while ($r778r = mysqli_fetch_array($r66631r)) {
                            $mysqli->query("INSERT INTO `tickets_emails_history` (`TicketID`, `UserID`, `Action`, `CreatedAt`) VALUES ('" . $r778r['TicketID'] . "', '1', '3', '$TodayIs')");
                            
                                    $res910 = $mysqli->query("SELECT `org_chart`.`Type`FROM `org_chart`, `user_chart` WHERE `org_chart`.`OCID` = `user_chart`.`OCID` AND `user_chart`.`UserID` = '$UserID'");
        $row910 = mysqli_fetch_array($res910);
       if ($row910['Type'] == 1) {
          $SubContractor1 = " `Status`, ";
          $SubContractor2 = " , 'QCApproval' ";
        }
        
    $Token = bin2hex(random_bytes(10));
    $res = $mysqli->query("INSERT INTO `rd5_reports` (`Token`, `UserID`, `TicketID` $SubContractor1 ,`CreatedAt`) VALUES ('$Token', '".$r778r['UserID']."', '".$r778r['TicketID']."' $SubContractor2 ,'$TodayIs')");

                        }
                    }

                    $return["error"] = false;
                } catch (Exception $e) {
                    $return["error"] = true;
                    $return["message"] = "Message could not be sent. Mailer Error: {$mail->ErrorInfo}";
                }

                $return["EmailStatus"] = true;
            } else {
                $return["EmailStatus"] = false;
            }
        } else {
            $return["EmailStatus"] = false;
        }
    } else {
        $return["EmailStatus"] = false;
    }
}

header('Content-Type: application/json');
echo json_encode($return);
