<?php

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

ob_start('ob_gzhandler');
include('../../api/config.php');

require '../../../inspection.cpvarabia.com/wordlib/phpmailer/src/Exception.php';
require '../../../inspection.cpvarabia.com/wordlib/phpmailer/src/PHPMailer.php';
require '../../../inspection.cpvarabia.com/wordlib/phpmailer/src/SMTP.php';
require '../../../inspection.cpvarabia.com/wordlib/vendor/autoload.php';

$Data = json_decode(file_get_contents('php://input'));
$PerToken = trim($Data->PerToken);
$PerUserID = trim($Data->PerUserID);
$PerRoleID = trim($Data->PerRoleID);
$ReferenceNo = $Data->ReferenceNo;
$RD5Responsible = $Data->RD5Responsible;
$TodayIs = date("Y-m-d H:i:s");

$UserCheck = $mysqli->query("SELECT Token FROM `login_tokens` WHERE `UID` = '$PerUserID' and `Token` = '$PerToken' limit 1");
$UserCheckRow = mysqli_num_rows($UserCheck);
if ($UserCheckRow == 0) {
    $return["error"] = true;
    $return["message"] = "Access denied!";
} else {
    $res1 = $mysqli->query("SELECT `ProjectID` FROM `projects` WHERE `ReferenceNo` = '$ReferenceNo' ");
    $row = mysqli_fetch_array($res1);
    $re44s = $mysqli->query("SELECT * FROM `rd7_reports` WHERE `ProjectID` = '" . $row['ProjectID'] . "' AND `Status` = '0' ");
    $r55 = mysqli_fetch_array($re44s);
    $RD7CheckRow = mysqli_num_rows($re44s);
    if ($RD7CheckRow == 0) {

        $res22 = $mysqli->query("SELECT `RD7ID` FROM `rd7_reports` WHERE `Status` != '12' AND `ProjectID`= '" . $row['ProjectID'] . "' ");
        $numrows122 = mysqli_num_rows($res22);
        if ($numrows122 == 0) {
            $res = $mysqli->query("INSERT INTO `rd7_reports` (`ProjectID`,`InsUserID`, `Status`, `CreatedBy`, `CreatedAt`) VALUES ('" . $row['ProjectID'] . "', '$RD5Responsible', '1', '$PerUserID', '$TodayIs')");
            if ($res) {
                $mail = new PHPMailer(true);

                try {
                    //Server settings
                    //$mail->SMTPDebug = SMTP::DEBUG_SERVER;                      //Enable verbose debug output
                    $mail->isSMTP();                                            //Send using SMTP
                    $mail->Host       = 'mail.rdapp.net';                     //Set the SMTP server to send through
                    $mail->SMTPAuth   = true;                                   //Enable SMTP authentication
                    $mail->Username   = 'cpvtest@rdapp.net';                     //SMTP username
                    $mail->Password   = 'x39cyh2a2es5';                               //SMTP password
                    $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;            //Enable implicit TLS encryption
                    $mail->Port       = 465;                                    //TCP port to connect to; use 587 if you have set `SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS`
                    $mail->CharSet = 'UTF-8';

                    //Recipients
                    $mail->setFrom('cpvtest@rdapp.net', 'CPV Arabia Tools');
                    $mail->addAddress($Inspector);
                    $mail->addCC($Moderator);
                    $mail->addCC('kadel@cpvarabia.com');
                    $mail->addBCC('cpvtest@rdapp.net');

                    //Content
                    $mail->isHTML(true);                                  //Set email format to HTML
                    $mail->Subject = 'Request RD5 #' . $ReferenceNo;
                    $mail->Body = '';

                    $mail->Body .= ' <body style="text-align:right; direction:rtl;">
    <p>“Dear Engr,<br />
    Kindly provide us with RD5 Report for project #' . $ReferenceNo . ' ASAP.<br />
    Best regards<br />
    CPVARABIA<br />';

                    if ($mail->send()) {
                        $r66631r = $mysqli->query("update `rd7_reports` set `Status` = '$Status' where `RD7ID` = '$RD7ID'");
                        while ($r778r = mysqli_fetch_array($r66631r)) {
                            $mysqli->query("INSERT INTO `rd7_history` (`RD7ID`, `UpdaterID`, `Action`, `Email`, `CreatedAt`) VALUES ('$RD7ID', '$PerUserID', 'Waiting for RD5','1' , '$TodayIs')");
                        }
                    }

                    $return["error"] = false;
                } catch (Exception $e) {
                    $return["error"] = true;
                    $return["message"] = "Message could not be sent. Mailer Error: {$mail->ErrorInfo}";
                }
                $return["error"] = false;
            } else {
                $return["error"] = true;
                $return["message"] = "Error!";
            }
        } else {
            $return["error"] = true;
            $return["message"] = "This Project Already Have active RD7!";
        }
    } else {
        $return["error"] = true;
        $return["message"] = "Error!";
    }
}

header('Content-Type: application/json');
echo json_encode($return);
