<?php
ob_start('ob_gzhandler');
include('../../api/config.php');

$Data = json_decode(file_get_contents('php://input'));
$PerToken = trim($Data->PerToken);
$PerUserID = trim($Data->PerUserID);
$PerRoleID = trim($Data->PerRoleID);
$ProjectID = $Data->ProjectID;
$Type = $Data->Type;
if (!empty($Type) and $Type == 'DR') {
    $TypeID = 14;
} else if (!empty($Type) and $Type == 'RD1') {
    $TypeID = 13;
} else if (!empty($Type) and $Type == 'RD2') {
    $TypeID = 15;
} else {
    $TypeID = 0;
}

$UserCheck = $mysqli->query("SELECT Token FROM `login_tokens` WHERE `UID` = '$PerUserID' and `Token` = '$PerToken' limit 1");
$UserCheckRow = mysqli_num_rows($UserCheck);
if ($UserCheckRow == 0) {
    $return["error"] = true;
    $return["message"] = "Access denied!";
} else {

    if (!empty($ProjectID) and !empty($Type)) {

        $return["error"] = false;

        $res = $mysqli->query("SELECT `project_stages`.*, `SP_reports`.`SPID` FROM `project_stages`,`SP_reports` WHERE `project_stages`.`ProjectID` = `SP_reports`.`ProjectID` and `project_stages`.`ProjectID` = '$ProjectID' and `StageID` = '$TypeID' and `project_stages`.`Deleted` = '0' ORDER BY `project_stages`.`StageDate` DESC");
$numrows1 = mysqli_num_rows($res);
                if ($numrows1 > 0) {
        while ($row = $res->fetch_assoc()) {
            $return[$row['PStageID']]['SPID'] = $row['SPID'];
            $return[$row['PStageID']]['PStageID'] = $row['PStageID'];
            $return[$row['PStageID']]['UserID'] = $row['InspectorID'];
            $return[$row['PStageID']]['Rev'] = $row['Rev'];
            $return[$row['PStageID']]['StageDate'] = $row['StageDate'];
            $return[$row['PStageID']]['RejectedReason'] = $row['RejectedReason'];
            $return[$row['PStageID']]['Status'] = $row['Status'];
            if ($Type == 'RD2') {
                $linkc = 'https://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_S_RD2.docx';
                if (@file_get_contents($linkc)) {
                    $return[$row['PStageID']]['Link'] = 'https://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_S_RD2.docx';
                } else {
                    $return[$row['PStageID']]['Link'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/RD2.php?PStageID=' . $row['PStageID'];
                }
            } else {
                if (!empty($row['PStageID'])) {
                    $linkc = 'https://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_' . $Type . '_C_V.docx';
                    if (@file_get_contents($linkc)) {
                        $return[$row['PStageID']]['LinkC'] = 'https://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_' . $Type . '_C_V.docx';
                    } else {
                        $return[$row['PStageID']]['LinkC'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/' . $Type . '.php?PStageID=' . $row['PStageID'];
                    }
                } else {
                    $links = 'https://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_' . $Type . '_S_V.docx';

                    if (@file_get_contents($links)) {
                        $return[$row['PStageID']]['LinkS'] = 'https://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_' . $Type . '_S_V.docx';
                    } else {
                        $return[$row['PStageID']]['LinkS'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/' . $Type . 'S.php?ProjectID=' . $ProjectID;
                    }
                }
            }


            $resx10 = $mysqli->query("SELECT * FROM `users` where `UserID` = '" . $row['InspectorID'] . "'");
            $row10 = mysqli_fetch_array($resx10);
            $return[$row['PStageID']]['UserName'] = $row10['FirstName'] . " " . $row10['LastName'];
        }
        }else{
             $links = 'https://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_' . $Type . '_S_V.docx';

                    if (@file_get_contents($links)) {
                        $return[1]['LinkS'] = 'https://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_' . $Type . '_S_V.docx';
                    } else {
                        $return[1]['LinkS'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/' . $Type . 'S.php?ProjectID=' . $ProjectID;
                    }
        }
    } else {
        $return["error"] = true;
        $return["message"] = "Error!";
    }
}

header('Content-Type: application/json');
echo json_encode($return);
